diff --git a/drivers/hwmon/w83627ehf.c b/drivers/hwmon/w83627ehf.c
index 207cc74..0a13f6b 100644
--- a/drivers/hwmon/w83627ehf.c
+++ b/drivers/hwmon/w83627ehf.c
@@ -1199,22 +1199,22 @@ store_tolerance(struct device *dev, struct device_attribute *attr,
 	return count;
 }
 
-SENSOR_DEVICE_ATTR(pwm1_target, 0644, show_target_temp,
+static SENSOR_DEVICE_ATTR(pwm1_target, 0644, show_target_temp,
 	    store_target_temp, 0);
-SENSOR_DEVICE_ATTR(pwm2_target, 0644, show_target_temp,
+static SENSOR_DEVICE_ATTR(pwm2_target, 0644, show_target_temp,
 	    store_target_temp, 1);
-SENSOR_DEVICE_ATTR(pwm3_target, 0644, show_target_temp,
+static SENSOR_DEVICE_ATTR(pwm3_target, 0644, show_target_temp,
 	    store_target_temp, 2);
-SENSOR_DEVICE_ATTR(pwm4_target, 0644, show_target_temp,
+static SENSOR_DEVICE_ATTR(pwm4_target, 0644, show_target_temp,
 	    store_target_temp, 3);
 
-SENSOR_DEVICE_ATTR(pwm1_tolerance, 0644, show_tolerance,
+static SENSOR_DEVICE_ATTR(pwm1_tolerance, 0644, show_tolerance,
 	    store_tolerance, 0);
-SENSOR_DEVICE_ATTR(pwm2_tolerance, 0644, show_tolerance,
+static SENSOR_DEVICE_ATTR(pwm2_tolerance, 0644, show_tolerance,
 	    store_tolerance, 1);
-SENSOR_DEVICE_ATTR(pwm3_tolerance, 0644, show_tolerance,
+static SENSOR_DEVICE_ATTR(pwm3_tolerance, 0644, show_tolerance,
 	    store_tolerance, 2);
-SENSOR_DEVICE_ATTR(pwm4_tolerance, 0644, show_tolerance,
+static SENSOR_DEVICE_ATTR(pwm4_tolerance, 0644, show_tolerance,
 	    store_tolerance, 3);
 
 /* Smart Fan registers */
@@ -1291,35 +1291,35 @@ store_##reg(struct device *dev, struct device_attribute *attr, \
 
 fan_time_functions(fan_stop_time, FAN_STOP_TIME)
 
-SENSOR_DEVICE_ATTR(pwm4_stop_time, 0644, show_fan_stop_time,
+static SENSOR_DEVICE_ATTR(pwm4_stop_time, 0644, show_fan_stop_time,
 	    store_fan_stop_time, 3);
-SENSOR_DEVICE_ATTR(pwm4_start_output, 0644, show_fan_start_output,
+static SENSOR_DEVICE_ATTR(pwm4_start_output, 0644, show_fan_start_output,
 	    store_fan_start_output, 3);
-SENSOR_DEVICE_ATTR(pwm4_stop_output, 0644, show_fan_stop_output,
+static SENSOR_DEVICE_ATTR(pwm4_stop_output, 0644, show_fan_stop_output,
 	    store_fan_stop_output, 3);
-SENSOR_DEVICE_ATTR(pwm4_max_output, 0644, show_fan_max_output,
+static SENSOR_DEVICE_ATTR(pwm4_max_output, 0644, show_fan_max_output,
 	    store_fan_max_output, 3);
-SENSOR_DEVICE_ATTR(pwm4_step_output, 0644, show_fan_step_output,
+static SENSOR_DEVICE_ATTR(pwm4_step_output, 0644, show_fan_step_output,
 	    store_fan_step_output, 3);
 
-SENSOR_DEVICE_ATTR(pwm3_stop_time, 0644, show_fan_stop_time,
+static SENSOR_DEVICE_ATTR(pwm3_stop_time, 0644, show_fan_stop_time,
 	    store_fan_stop_time, 2);
-SENSOR_DEVICE_ATTR(pwm3_start_output, 0644, show_fan_start_output,
+static SENSOR_DEVICE_ATTR(pwm3_start_output, 0644, show_fan_start_output,
 	    store_fan_start_output, 2);
-SENSOR_DEVICE_ATTR(pwm3_stop_output, 0644, show_fan_stop_output,
+static SENSOR_DEVICE_ATTR(pwm3_stop_output, 0644, show_fan_stop_output,
 		    store_fan_stop_output, 2);
 
-SENSOR_DEVICE_ATTR(pwm1_stop_time, 0644, show_fan_stop_time,
+static SENSOR_DEVICE_ATTR(pwm1_stop_time, 0644, show_fan_stop_time,
 	    store_fan_stop_time, 0);
-SENSOR_DEVICE_ATTR(pwm2_stop_time, 0644, show_fan_stop_time,
+static SENSOR_DEVICE_ATTR(pwm2_stop_time, 0644, show_fan_stop_time,
 	    store_fan_stop_time, 1);
-SENSOR_DEVICE_ATTR(pwm1_start_output, 0644, show_fan_start_output,
+static SENSOR_DEVICE_ATTR(pwm1_start_output, 0644, show_fan_start_output,
 	    store_fan_start_output, 0);
-SENSOR_DEVICE_ATTR(pwm2_start_output, 0644, show_fan_start_output,
+static SENSOR_DEVICE_ATTR(pwm2_start_output, 0644, show_fan_start_output,
 	    store_fan_start_output, 1);
-SENSOR_DEVICE_ATTR(pwm1_stop_output, 0644, show_fan_stop_output,
+static SENSOR_DEVICE_ATTR(pwm1_stop_output, 0644, show_fan_stop_output,
 	    store_fan_stop_output, 0);
-SENSOR_DEVICE_ATTR(pwm2_stop_output, 0644, show_fan_stop_output,
+static SENSOR_DEVICE_ATTR(pwm2_stop_output, 0644, show_fan_stop_output,
 	    store_fan_stop_output, 1);
 
 
@@ -1327,17 +1327,17 @@ SENSOR_DEVICE_ATTR(pwm2_stop_output, 0644, show_fan_stop_output,
  * pwm1 and pwm3 don't support max and step settings on all chips.
  * Need to check support while generating/removing attribute files.
  */
-SENSOR_DEVICE_ATTR(pwm1_max_output, 0644, show_fan_max_output,
+static SENSOR_DEVICE_ATTR(pwm1_max_output, 0644, show_fan_max_output,
 	    store_fan_max_output, 0);
-SENSOR_DEVICE_ATTR(pwm1_step_output, 0644, show_fan_step_output,
+static SENSOR_DEVICE_ATTR(pwm1_step_output, 0644, show_fan_step_output,
 	    store_fan_step_output, 0);
-SENSOR_DEVICE_ATTR(pwm2_max_output, 0644, show_fan_max_output,
+static SENSOR_DEVICE_ATTR(pwm2_max_output, 0644, show_fan_max_output,
 	    store_fan_max_output, 1);
-SENSOR_DEVICE_ATTR(pwm2_step_output, 0644, show_fan_step_output,
+static SENSOR_DEVICE_ATTR(pwm2_step_output, 0644, show_fan_step_output,
 	    store_fan_step_output, 1);
-SENSOR_DEVICE_ATTR(pwm3_max_output, 0644, show_fan_max_output,
+static SENSOR_DEVICE_ATTR(pwm3_max_output, 0644, show_fan_max_output,
 	    store_fan_max_output, 2);
-SENSOR_DEVICE_ATTR(pwm3_step_output, 0644, show_fan_step_output,
+static SENSOR_DEVICE_ATTR(pwm3_step_output, 0644, show_fan_step_output,
 	    store_fan_step_output, 2);
 
 static ssize_t